diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index 678be17..694efd6 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,7 @@
+2014-03-26  Yao Qi  <yao@codesourcery.com>
+
+	* gdb.base/macscp.exp: Fix code format issues.
+
 2014-03-25  Ulrich Weigand  <uweigand@de.ibm.com>
 
 	* gdb.asm/asm-source.exp: Handle powerpc64le-* targets.
diff --git a/gdb/testsuite/gdb.base/macscp.exp b/gdb/testsuite/gdb.base/macscp.exp
index 2e776a0..e953c0d 100644
--- a/gdb/testsuite/gdb.base/macscp.exp
+++ b/gdb/testsuite/gdb.base/macscp.exp
@@ -522,50 +522,53 @@ gdb_test "macro undef" \
 # The macro FIFTY_SEVEN is in scope at this point.
 send_gdb "p FIFTY_\t"
 gdb_expect  {
-        -re "^p FIFTY_SEVEN $"\
-            { send_gdb "\n"
-              gdb_expect {
-                      -re "^.* = 57.*$gdb_prompt $"\
-                                        { pass "complete 'p FIFTY_SEVEN'"}
-                      -re ".*$gdb_prompt $" { fail "complete 'p FIFTY_SEVEN'"}
-                      timeout           {fail "(timeout) complete 'p FIFTY_SEVEN'"}
-                     }
-            }
-        -re ".*$gdb_prompt $"       { fail "complete 'p FIFTY_SEVEN'" }
-        timeout         { fail "(timeout) complete 'p FIFTY_SEVEN' 2" }
-        }
+    -re "^p FIFTY_SEVEN $" {
+	send_gdb "\n"
+	gdb_expect {
+	    -re "^.* = 57.*$gdb_prompt $" {
+		pass "complete 'p FIFTY_SEVEN'"
+	    }
+	    -re ".*$gdb_prompt $" { fail "complete 'p FIFTY_SEVEN'" }
+	    timeout { fail "(timeout) complete 'p FIFTY_SEVEN'" }
+	    }
+	}
+    -re ".*$gdb_prompt $" { fail "complete 'p FIFTY_SEVEN'" }
+    timeout { fail "(timeout) complete 'p FIFTY_SEVEN' 2" }
+}
 
 # The macro TWENTY_THREE is not in scope.
 send_gdb "p TWENTY_\t"
 gdb_expect  {
-        -re "^p TWENTY_\\\x07$"\
-            { send_gdb "\n"
-              gdb_expect {
-                      -re "No symbol \"TWENTY_\" in current context\\..*$gdb_prompt $"\
-                                        { pass "complete 'p TWENTY_'"}
-                      -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_'"}
-                      timeout           {fail "(timeout) complete 'p TWENTY_'"}
-                     }
-            }
-        -re ".*$gdb_prompt $"       { fail "complete 'p TWENTY_'" }
-        timeout         { fail "(timeout) complete 'p TWENTY_' 2" }
-        }
+    -re "^p TWENTY_\\\x07$" {
+	send_gdb "\n"
+	gdb_expect {
+	    -re "No symbol \"TWENTY_\" in current context\\..*$gdb_prompt $" {
+		pass "complete 'p TWENTY_'"
+	    }
+	    -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_'" }
+	    timeout { fail "(timeout) complete 'p TWENTY_'"}
+	}
+    }
+    -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_'" }
+    timeout { fail "(timeout) complete 'p TWENTY_' 2" }
+}
 
 # The macro FORTY_EIGHT was undefined and thus is not in scope.
 send_gdb "p FORTY_\t"
 gdb_expect  {
-        -re "^p FORTY_\\\x07$"\
-            { send_gdb "\n"
-              gdb_expect {
-                      -re "No symbol \"FORTY_\" in current context\\..*$gdb_prompt $"\
-                                        { pass "complete 'p FORTY_'"}
-                      -re ".*$gdb_prompt $" { fail "complete 'p FORTY_'"}
-                      timeout           {fail "(timeout) complete 'p FORTY_'"}
-                     }
-            }
-        -re ".*$gdb_prompt $"       { fail "complete 'p FORTY_'" }
-        timeout         { fail "(timeout) complete 'p FORTY_' 2" }
-        }
+    -re "^p FORTY_\\\x07$" {
+	send_gdb "\n"
+	gdb_expect {
+	    -re "No symbol \"FORTY_\" in current context\\..*$gdb_prompt $" {
+		pass "complete 'p FORTY_'"
+	    }
+	    -re ".*$gdb_prompt $" { fail "complete 'p FORTY_'" }
+	    timeout {fail "(timeout) complete 'p FORTY_'"}
+	    }
+	}
+    -re ".*$gdb_prompt $" { fail "complete 'p FORTY_'" }
+    timeout { fail "(timeout) complete 'p FORTY_' 2" }
+}
 
 gdb_test_no_output "macro define TWENTY_THREE 25" \
   "defining TWENTY_THREE"
@@ -573,18 +576,19 @@ gdb_test_no_output "macro define TWENTY_THREE 25" \
 # User-defined macros are always in scope.
 send_gdb "p TWENTY_\t"
 gdb_expect  {
-        -re "^p TWENTY_THREE $"\
-            { send_gdb "\n"
-              gdb_expect {
-                      -re "^.* = 25.*$gdb_prompt $"\
-                                        { pass "complete 'p TWENTY_THREE'"}
-                      -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_THREE'"}
-                      timeout           {fail "(timeout) complete 'p TWENTY_THREE'"}
-                     }
-            }
-        -re ".*$gdb_prompt $"       { fail "complete 'p TWENTY_THREE'" }
-        timeout         { fail "(timeout) complete 'p TWENTY_THREE' 2" }
-        }
+    -re "^p TWENTY_THREE $" {
+	send_gdb "\n"
+	gdb_expect {
+	    -re "^.* = 25.*$gdb_prompt $" {
+		pass "complete 'p TWENTY_THREE'"
+	    }
+	    -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_THREE'"}
+	    timeout { fail "(timeout) complete 'p TWENTY_THREE'" }
+	}
+    }
+    -re ".*$gdb_prompt $" { fail "complete 'p TWENTY_THREE'" }
+    timeout { fail "(timeout) complete 'p TWENTY_THREE' 2" }
+}
 
 # Splicing tests.
 